/******************************************************************************/
/*  ZL5ARM - LCD                                                              */
/******************************************************************************/
                  
#include <LPC21xx.H>
#include "const_bit.h"
#include "lcd.h"
				
#define del_l 0x400000
#define del_s 0x10000

void delay (unsigned int del_time);

int main (void)
{

  IODIR0 = 0xFF000000;
  IODIR1 = 0x00FF0000;

  PINSEL1 &= !(BIT26 | BIT27 | BIT28 | BIT29);

  LCDInit();

  LCDSendByte(0x01,0);				// clrscr
  delay(del_s);

  LCDSendByte(' ',1);  delay(del_l);
  LCDSendByte(' ',1);  delay(del_l);
  LCDSendByte(' ',1);  delay(del_l);
  LCDSendByte('*',1);  delay(del_l);
  LCDSendByte(' ',1);  delay(del_l);
  LCDSendByte('Z',1);  delay(del_l);
  LCDSendByte('L',1);  delay(del_l);
  LCDSendByte('5',1);  delay(del_l);
  LCDSendByte('A',1);  delay(del_l);
  LCDSendByte('R',1);  delay(del_l);
  LCDSendByte('M',1);  delay(del_l);
  LCDSendByte(' ',1);  delay(del_l);
  LCDSendByte('*',1);  delay(del_l);

  LCDTextXY(0, 1, "Nacisnij S1...S4");

  while (1)
  {
    delay(del_s);
  	IOCLR1 = 0x00FF0000;				// wycz diody
	// S1 doczony do P0.4
	if( !(IOPIN0 & BIT4))
	{
      IOSET1 = 0x00FF0000 & (BIT0 << 16);
	}

	// S2 doczony do P0.5
	if( !(IOPIN0 & BIT5))
	{
      IOSET1 = 0x00FF0000 & (BIT1 << 16);
	}

	// S3 doczony do P0.6
	if( !(IOPIN0 & BIT6))
	{
      IOSET1 = 0x00FF0000 & (BIT2 << 16);
	}

	// S4 doczony do P0.7
	if( !(IOPIN0 & BIT7))
	{
      IOSET1 = 0x00FF0000 & (BIT3 << 16);
	}
	       
  } // while
 

}
/////////////////////////////////////////////////////////////

void delay (unsigned int del_time) 
{ 
  unsigned int i;
  
  for(i = 0; i < del_time; i++);	   
}								    

