/******************************************************************************/
/*  ZL5ARM - UART                                                             */
/* wartoci z przetwornika AC s wysyane przez UART (zcze J3)              */
/******************************************************************************/
                  
#include <LPC21xx.H>	    
#include "const_bit.h"
#include "lcd.h"
#include "uart.h"

#define del_l 0x400000
#define del_s 0x10000
				  
void delay (unsigned int del_time);
void LCD_Hex(int hex);

int main (void)
{
  unsigned int val;

  IODIR0 = 0xFF000000; 
  IODIR1 = 0x00FF0000;

  PINSEL1 &= !(BIT26 | BIT27 | BIT28 | BIT29);

  PINSEL1 |= BIT22;
  ADCR   = 0x002E0401;              // Setup A/D: 10-bit AIN0 @ 3MHz

  LCDInit();

  LCDSendByte(0x01,0);				// clrscr
  delay(del_s);

  LCDSendByte(' ',1);  delay(del_l);
  LCDSendByte(' ',1);  delay(del_l);
  LCDSendByte(' ',1);  delay(del_l);
  LCDSendByte('*',1);  delay(del_l);
  LCDSendByte(' ',1);  delay(del_l);
  LCDSendByte('Z',1);  delay(del_l);
  LCDSendByte('L',1);  delay(del_l);
  LCDSendByte('5',1);  delay(del_l);
  LCDSendByte('A',1);  delay(del_l);
  LCDSendByte('R',1);  delay(del_l);
  LCDSendByte('M',1);  delay(del_l);
  LCDSendByte(' ',1);  delay(del_l);
  LCDSendByte('*',1);  delay(del_l);
  delay(del_l);

  LCDTextXY(0, 1, " * www.btc.pl *");
  delay(4*del_l);
        		 
  init_serial();

  LCDTextXY(0,1, "  AC->UART (J3)  ");  

  while (1)
  {
      ADCR |= 0x01000000;                      // start konwersji AC
      do
	  {
        val = ADDR;                            // odczytaj wynik konwersji
      } while ((val & 0x80000000) == 0);       // czekaj na koniec konwersji AC
      ADCR &= ~0x01000000;                     // koniec konwersji AC
      val = (val >> 6) & 0x03FF;

      putstr ("\nAIN0 = 0x");
      puthex((val >> 8) & 0x0F);               //  1 cyfra
      puthex((val >> 4) & 0x0F);               //  2 cyfra
      puthex(val & 0x0F);                      //  3 cyfra

      val = (val >> 2) & 0x00FF;
      IOCLR1 = 0x00FF0000;                     // wycz diody
      IOSET1 = 0x00FF0000 & (val << 16);	   // 8 bardziej znaczcych bitw konwersji na LED
  } // while
}
/////////////////////////////////////////////////////////////

void delay (unsigned int del_time) 
{ 
  unsigned int i;
  
  for(i = 0; i < del_time; i++);	   
}							    


void LCD_Hex(int hex)
// Write Hex Digit on LCD
{
  if (hex > 9) LCDSendByte('A' + (hex - 10),1);
  else         LCDSendByte('0' +  hex,1);
}
