#include "uart.h"

#define CR     0x0D

void init_serial (void)
{
  PINSEL0 = 0x00050000;                  // RxD1 i TxD1
  U1LCR = 0x83;                          // 8 bit, no Parity, 1 Stop bit
  U1DLL = 97;                            // 9600 bps
  U1LCR = 0x03; 
}


int putchar (int ch)
// wylij znak przez UART
{
  if (ch == '\n')
  {
    while (!(U1LSR & 0x20));
    U1THR = CR;
  }
  while (!(U1LSR & 0x20));
  return (U1THR = ch);
}


int getchar (void)
// odczytaj znak
{
  while (!(U1LSR & 0x01));

  return (U1RBR);
}


void puthex (int hex)
// wylij liczb hex przez UART
{
  if (hex > 9) putchar('A' + (hex - 10));
  else         putchar('0' +  hex);
}


void putstr (char *p)
// wylij string przez UART
{
  while (*p)
  {
    putchar (*p++);
  }
}
